// 配列に対して繰り返し処理を行う
for (let v of [1, 2, 3]) {
    console.log(v);
    // => 1
    //    2
    //    3
}

// 文字列に対して繰り返し処理を行う
for (let v of "Hi!") {
    // 順に 
    console.log(v);
    // => H
    //    i
    //    !
}

// Generatorを使ってIteratorを作り出す
function* gen() {
    yield 1;
    yield 2;
    yield 3;
}
for (let v of gen()) {
    console.log(v);
    // => 1
    //    2
    //    3
}

// Symbol.iteratorでIterableな値を返すとfor-ofで使える
const obj = {
    [Symbol.iterator]: gen,
};
for (let v of obj) {
    console.log(v);
    // => 1
    //    2
    //    3
}
