const array = [1, 2, "a", "b"];

// everyはすべての要素が条件にマッチするかを調べる
console.log(array.every(v => typeof v === "number"));
// => false

// someはどれが1つでも条件にマッチする要素があるかを調べる
console.log(array.some(v => typeof v === "number"));
// => true

// findは一番初めに条件にマッチした要素のみを返す
console.log(array.find(v => typeof v === "number"));
// => 1

// filterはすべての要素のうち、条件にマッチした要素のみを集めて返す
console.log(array.filter(v => typeof v === "number"));
// => [ 1, 2 ]

// forEachはすべての要素に対して指定した処理を適用する
array.forEach(v => console.log(v));
// => 1
//    2
//    a
//    b

// map はすべての要素に対して指定した変換処理を適用し結果を集めて返す
console.log(array.map(v => `${v}!`));
// => [ '1!', '2!', 'a!', 'b!' ]

// includes は指定した要素が配列中に含まれるかを調べて返す
console.log(array.includes(2));
// => true

// 左側の要素から、順に処理し畳み込んでいく
console.log(array.reduce((p, c) => `${p},${c}`), "");
// => 1,2,a,b

// 右側の要素から、順に処理し畳み込んでいく
console.log(array.reduceRight((p, c) => `${p},${c}`), "");
// => b,a,2,1
