// 関数の仮引数でも使えるが……
// 乱用はダメ、絶対！
function generateConfiguration({isProduction, libPath}) {
    // このあたりに5行くらい処理が挟まると、
    // どこから来た変数か忘れてしまいがち

    return {
        uglify: !!isProduction,
        libPath: libPath || "./src/",
    };
}

const confA = generateConfiguration({
    isProduction: true,
    libPath: "./lib/",
});
console.log(confA);
// => { uglify: true, libPath: './lib/' }

const confB = generateConfiguration({ libPath: "./lib/" });
console.log(confB);
// => { uglify: false, libPath: './lib/' }

// 今までの書き方のほうがわかりやすいのでは……？
function generateConfigurationB(settings) {
    // 宣言の行からreturnまでに長いコードが挟まっていても、
    // 引数由来の値であるとわかりやすい

    return {
        uglify: !!settings.isProduction,
        libPath: settings.libPath || "./src/",
    };
}
