const obj = {
    type: "cat",
    kind: "maincoon",
    name: "まや",
    likes: ["毛繕い", "ほかの猫が寝ている上に寝ること"],
};

// オブジェクトの特定のプロパティを分割して切り出せる
const { kind, name, } = obj;
console.log(kind, name);
// => maincoon まや

const array = [1, 2, 3, 4];
// 配列の要素も分割して切り出せる
const [, second, ...rest] = array;
console.log(second, rest);
// => 2 [ 3, 4 ]

// 複雑な分割のしかたもできる（読みづらくなるので注意）
const { name: nickname, likes: [like1st]} = obj;
console.log(nickname, like1st);
// => まや 毛繕い

// 利用する変数名とプロパティ名が同じなら
// {kind:kind, name:name} より短く書ける
const objA = { kind, name };
console.log(objA);
// => { kind: 'maincoon', name: 'まや' }
