// 引数 b はデフォルト値付き引数
// 引数 args は可変長引数
function funcA(a, b = 1, ...args) {
    console.log(a, b, args);
}

funcA();
// => undefined 1 []
funcA("a", 2, true, false);
// => a 2 [ true, false ]
const array = [true, false];
funcA("a", 2, ...array);
// => a 2 [ true, false ]

// デフォルト値付き引数のいろいろな挙動
function funcB(a = "Hi") {
    console.log(`${a}, JavaScript!`);
}

funcB();
// => Hi, JavaScript!
funcB(undefined);
// => Hi, JavaScript!
funcB(null);
// => null, JavaScript!
funcB("");
// => , JavaScript!

// 旧来のやり方のほうが適している場合もある
function funcC(a) {
    a = a || "Hi";
    console.log(`${a}, JavaScript!`);
}
// 以下はすべて「Hi!, JavaScript!」と表示される
funcC();
funcC(undefined);
funcC(null);
funcC("");
