const funcA = () => { };
const funcB = function () { };
// 普通の関数には名前が付けられる
function funcC() { };

// 普通の関数では定義の巻き上げが可能
// 実際に定義しているのは呼び出しのコードよりも下だが、正しく動く
funcZ();
function funcZ() {
}

class Sample {
    method() {
        const a = () => {
            // アロー関数は外側のthisを引き継ぐ
            console.log(this);
        };
        const b = function () {
            // 普通の関数ではthisの値が呼び出し方によって変わる
            console.log(this);
        };
        // アロー関数：外側のthisを引き継ぎ、「Sample {}」と表示される
        a();
        // 普通の関数：「undefined」と表示される
        b();
        // アロー関数：外側のthisを引き継ぎ、「Sample {}」と表示される
        a.bind(1)();
        // 普通の関数：bindで指定された「1」が表示される
        b.bind(1)();
    }
}
let objA = new Sample();
objA.method();

// method自体のthisの値を変えてしまえば、
// アロー関数内部のthisの値も変わってしまう
let objB = {
    name: "objB",
    method: objA.method,
}
// 同じSample#methodのはずだが以下のように出力される
// これは、thisがSampleのインスタンスではなくobjBになるからである
// a(); の部分        ：{ name: 'objB', method: [Function: method] }
// b(); の部分        ：undefined
// a.bind(1)(); の部分：{ name: 'objB', method: [Function: method] }
// b.bind(1)(); の部分：1
objB.method();
